unit uComp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ImgList, ComCtrls, Buttons,
  IBDatabase, Db, IBCustomDataSet, IBQuery, DBLOGDLG;

type
  TfCompara = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    EdPonto: TEdit;
    EdComp: TEdit;
    BtnPonto: TButton;
    BtnComp: TButton;
    OpenDialog1: TOpenDialog;
    Tree: TTreeView;
    BtnIni: TBitBtn;
    IBComp: TIBDatabase;
    QrComp: TIBQuery;
    TRComp: TIBTransaction;
    IBPonto: TIBDatabase;
    QRPonto: TIBQuery;
    TRPonto: TIBTransaction;
    ImageList1: TImageList;
    Panel3: TPanel;
    edscript: TEdit;
    BTNSCRIPT: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure AbreTable(Query: TIBQuery; Table: String);

    Function TraduzTipo(Tipo: TFieldType):String;

    procedure BtnPontoClick(Sender: TObject);
    procedure BtnIniClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fCompara: TfCompara;

implementation

{$R *.DFM}

procedure TfCompara.AbreTable(Query: TIBQuery; Table: String);
Begin
  With Query Do
  Begin
    Close;
    Query.Fields.Clear;
    
    SQL.Clear;
    SQL.Add('Select * from '+TRIM(Table));
    SQL.Add('Where 1 = 2'); // where para selecionar a table vazia

    Open;
      
  End;
End;

Function TfCompara.TraduzTipo(Tipo: TFieldType):String;
begin
   Case Tipo of
        ftUnknown    :	TraduzTipo := 'Unknown';
        ftString     :	TraduzTipo := 'String';
        ftSmallint   :	TraduzTipo := 'Smallint';
        ftInteger    :  TraduzTipo := 'Integer';
        ftWord	     :  TraduzTipo := 'LongInt';
        ftBoolean    :	TraduzTipo := 'Boolean';
        ftFloat	     :  TraduzTipo := 'Float';
        ftCurrency   :	TraduzTipo := 'Currency';
        ftBCD	     :  TraduzTipo := 'BCD';
        ftDate	     :  TraduzTipo := 'Date';
        ftTime       :  TraduzTipo := 'Time';
        ftDateTime   :	TraduzTipo := 'TimeStamp';
        ftBytes	     :  TraduzTipo := 'Bytes';
        ftVarBytes   :	TraduzTipo := 'Varbytes';
        ftAutoInc    :  TraduzTipo := 'Autoinc';
        ftBlob	     :  TraduzTipo := 'BLOB';
        ftMemo	     :  TraduzTipo := 'Memo';
        ftGraphic    :	TraduzTipo := 'Bitmap';
        ftFmtMemo    :	TraduzTipo := 'Formatted memo';
        ftTypedBinary:	TraduzTipo := 'Typed binary';
        ftCursor     :	TraduzTipo := 'Cursor';
        ftFixedChar  :	TraduzTipo := 'Fixed character';
        ftWideString :	TraduzTipo := 'Wide string';
        ftLargeInt   :	TraduzTipo := 'Large integer';
        ftVariant    :	TraduzTipo := 'Variant';
   End;
End;

procedure TfCompara.BtnPontoClick(Sender: TObject);
begin
  If OpenDialog1.Execute Then
    TEdit(fCompara.FindComponent('ED'+Trim(Copy((Sender as TButton).name,4,length((Sender as TButton).name))))).Text := '127.0.0.1:'+OpenDialog1.FileName;
end;

procedure TfCompara.BtnIniClick(Sender: TObject);
  var
      MyTreeNode1, MyChildNode1: TTreeNode;
      TbPonto, TbComp   : TStringList;

      I, J: Integer;
      Achou: Boolean;
      F: TEXTFILE;
begin
  IbPonto.Close;
  Try
    IbPonto.DatabaseName:=EdPonto.Text;
    IbPonto.Open;
  Except
    Application.MessageBox('No foi possivel abrir banco de Comparao !', 'Ponto de Comparao', mb_ok+mb_iconerror);
    EdPonto.Setfocus;
    Exit;
  End;

  IbComp.Close;
  Try
    IbComp.DatabaseName:=EdComp.Text;
    IbComp.Open;
  Except
    Application.MessageBox('No foi possivel abrir banco Comparado !', 'Banco Comparado', mb_ok+mb_iconerror);
    EdComp.Setfocus;
    Exit;
  End;

  IF TRIM(EDSCRIPT.TEXT) <> '' THEN
  BEGIN
    ASSIGNFILE(F, EDSCRIPT.TEXT);
    REWRITE(F);
  END;

  TbPonto := Nil;
  TbComp  := Nil;

  TbPonto := TStringList.Create;
  TbComp  := TStringList.Create;

  IbPonto.GetTableNames(TbComp);
  IbComp.GetTableNames(TbPonto);

  TbPonto.Sorted := True;
  TbComp.Sorted  := True;

  with Tree.Items do
  begin
    Clear;

    {Verificando se campos removidos ou alterados}
    For I := 0 To TbComp.Count-1 Do
    Begin
      Application.ProcessMessages;

      If TbPonto.Find(TbComp.Strings[i], j) Then
      Begin
        MyTreeNode1 := Add(nil, 'Tabela '+TbComp.Strings[i]);
        IF TRIM(EDSCRIPT.TEXT) <> '' THEN WRITELN(F, 'Tabela '+TbComp.Strings[i]);
        TREE.Select(MyTreeNode1);
        MyTreeNode1.ImageIndex := 3;

        AbreTable(QrPonto, TbComp.Strings[i]);
        AbreTable(QrComp, TbComp.Strings[i]);

        For J := 0 To QrComp.FieldCount-1 Do // Campo removido ou Alterado
        Begin
          If QrPonto.FindField(QrComp.Fields[J].FieldName) = nil Then
          Begin
            {verificando se removido}
            MyChildNode1 := AddChild(MyTreeNode1,'Campo '+QrComp.Fields[J].FieldName+' removido !');
            IF TRIM(EDSCRIPT.TEXT) <> '' THEN WRITELN(F, '      Campo '+QrComp.Fields[J].FieldName+' removido !');
            //IF TRIM(EDSCRIPT.TEXT) <> '' THEN
             // WRITELN(F, 'ALTER TABLE '+TbComp.Strings[i]+' DROP '+QrComp.Fields[J].FieldName+';');

            MyChildNode1.ImageIndex := 4;
          End Else
          Begin

            {Verificando se tipo alterado}
            If QrPonto.FieldByName(QrComp.Fields[J].FieldName).DataType <> QrPonto.FieldByName(QrComp.Fields[J].FieldName).DataType Then
            Begin
              MyChildNode1 := AddChild(MyTreeNode1,'Tipo do Campo '+QrComp.Fields[J].FieldName+' alterado de '+TraduzTipo(QrComp.Fields[J].DataType)+' para '+TraduzTipo(QrPonto.FieldByName(QrComp.Fields[J].FieldName).DataType));
              MyChildNode1.ImageIndex := 6;
              IF TRIM(EDSCRIPT.TEXT) <> '' THEN WRITELN(F, '      Campo '+QrComp.Fields[J].FieldName+' removido !');
            End;

            {Verificando se tamanho alterado}
            If QrPonto.FieldByName(QrComp.Fields[J].FieldName).DataSize <> QrPonto.FieldByName(QrComp.Fields[J].FieldName).DataSize Then
            Begin
              MyChildNode1 := AddChild(MyTreeNode1,'Tamanho do Campo '+QrComp.Fields[J].FieldName+' alterado de '+FloattoStr(QrComp.Fields[J].DataSize)+' para '+FloatToStr(QrPonto.FieldByName(QrPonto.Fields[J].FieldName).DataSize));
              IF TRIM(EDSCRIPT.TEXT) <> '' THEN WRITELN(F, '      Tamanho do Campo '+QrComp.Fields[J].FieldName+' alterado de '+FloattoStr(QrComp.Fields[J].DataSize)+' para '+FloatToStr(QrPonto.FieldByName(QrPonto.Fields[J].FieldName).DataSize));
              MyChildNode1.ImageIndex := 6;
            End;
          End;
        End;

        For J := 0 To QrPonto.FieldCount-1 Do // Campo Adicionado
        Begin
          If QrComp.FindField(QrPonto.Fields[J].FieldName) = nil Then
          Begin
            MyChildNode1 := AddChild(MyTreeNode1,'Campo '+QrPonto.Fields[J].FieldName+' adicionado no tipo '+TraduzTipo(QrPonto.Fields[J].DataType)+' com '+FloatToStr(QrPonto.Fields[J].DataSize)+' byte(s)');
            IF TRIM(EDSCRIPT.TEXT) <> '' THEN WRITELN(F, '      Campo '+QrPonto.Fields[J].FieldName+' adicionado no tipo '+TraduzTipo(QrPonto.Fields[J].DataType)+' com '+FloatToStr(QrPonto.Fields[J].DataSize)+' byte(s)');
            MyChildNode1.ImageIndex := 5;
          End;
        End;
      End;
      MyTreeNode1.Expand(True);
    End;
    {Verificando Tabelas Adicionadas}
    For I := 0 To TbComp.Count-1 Do
    Begin
      Achou := False;

      If NOT(TbPonto.Find(TbComp.Strings[i], j)) Then
      Begin
        MyTreeNode1 := Add(nil, 'Tabela '+TbComp.Strings[i]+' Adicionada !');
        IF TRIM(EDSCRIPT.TEXT) <> '' THEN WRITELN(F, 'Tabela '+TbComp.Strings[i]+' Adicionada !');
        MyTreeNode1.ImageIndex := 1;
      End;
    End;

    {Verificando Tabelas Removidas}
    For I := 0 To TbPonto.Count-1 Do
    Begin
      Achou := False;

      If NOT(TbComp.Find(TbPonto.Strings[i], j)) Then
      Begin
        MyTreeNode1 := Add(nil, 'Tabela '+TbPonto.Strings[i]+' Excluda !');
        IF TRIM(EDSCRIPT.TEXT) <> '' THEN WRITELN(F, 'Tabela '+TbPonto.Strings[i]+' Excluda !');
        MyTreeNode1.ImageIndex := 2;
      End;
    End;
  End;

  IF TRIM(EDSCRIPT.TEXT) <> '' THEN
    CLOSEFILE(F);


  FreeAndNil(TbPonto);
  FreeAndNil(TbComp);
  QrPonto.Close;
  QrComp.Close;
  FreeAndNil(MyTreeNode1);
  FreeAndNil(MyChildNode1);
  IBPonto.Close;
  IBComp.Close;

end;

procedure TfCompara.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  QrPonto.Close;
  QrComp.Close;
  IBPonto.Close;
  IBComp.Close;
end;

procedure TfCompara.FormKeyPress(Sender: TObject; var Key: Char);
begin
  If Key = #27 then
    Close;
end;

end.
